#include <plib.h>
#include <p32xxxx.h>
#include ".\..\App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		10

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "Write:  ,Read:  "; 
unsigned char Timer1TickFlag = 0;

#define NVM_Page_Base	0xbd008000
#define NVM_Page_Size	4096

void __ISR( _TIMER_1_VECTOR , ipl4 ) ISR_Timer1( void )
{
	Timer1TickFlag++;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

int main( void )
{
	unsigned long i = 0;
	unsigned int NVMOffset = 0;
	unsigned char * NVMDataPointer;

	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );
	
	// ϥC32 NVM FunctionMFlash PageC
	NVMErasePage( ( void * ) NVM_Page_Base );

	INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{

		if( Timer1TickFlag >= 1 )
		{
			Timer1TickFlag--;

			LCM_SetCursor( 6 , 1 );
			LCM_PutHex( NVMOffset >> 2 );
			NVMWriteWord( ( void * ) NVM_Page_Base + NVMOffset , NVMOffset >> 2 ); 

			// FlashgJ, O۷֪, L٬ONU[ө, 
			// @"˸mݭngJɶ"oƱ.
			for( i = 0; i < 1 ; i++ );

			LCM_SetCursor( 14 , 1 );
			NVMDataPointer = ( unsigned char * ) NVM_Page_Base + NVMOffset;

			LCM_PutHex( *NVMDataPointer );

			NVMOffset += 4;
			if( NVMOffset > 4095 )
			{
				NVMOffset = 0;

				//ϥC32 NVM FunctionsMFlash PageC
				NVMErasePage( ( void * ) NVM_Page_Base );
			}
		}
	}

	while( 1 );
}