#include <plib.h>
#include <p32xxxx.h>
#include ".\..\App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		1

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "Happend! Code=  "; 
unsigned char Timer1TickFlag = 0;

void __ISR( _TIMER_1_VECTOR , ipl4 ) ISR_Timer1( void )
{
	Timer1TickFlag++;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

	/* Exception Code Description */
	// 0x00 Interrupt
	// 0x04 Address error exception (load or instruction fetch)
	// 0x05 Address error exception (store)
	// 0x06 Bus error exception (instruction fetch)
	// 0x07 Bus error exception (data reference: load or store)
	// 0x08 Syscall exception
	// 0x09 Breakpoint exception
	// 0x0a Reserved instruction exception
	// 0x0b CPU Coprocessor Unusable exception
	// 0x0c Arithmetic Overflow exception
	// 0x0d Tr Trap exception
	// 0x0e-0x12 Reserved

void _general_exception_handler ( unsigned int cause , unsigned int status )
{
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	LCM_SetCursor( 14 , 1 );
	LCM_PutHex( ( cause >> 2 ) & 0x000000ff );

	while( 1 );
}

int main( void )
{
	unsigned char Var1 = 10;
	unsigned char Var2 = 10;

	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );

	INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		if( Timer1TickFlag >= 1 ) 	
		{
			Timer1TickFlag--;

			// pQ, oͰsp( Var2 = 0 ), ޵oException
			Var1 /= --Var2;
		}
	}

	while( 1 );
}